! ++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
!  MIDAS procedure verifyQC.prg  to verify the plotting procedures of QC
!  K. Banse     080410
!
! use via: @@ verifyQC cntrl-flag option plot-flag
!	cntrl-flg = 1 create new Postscript files from Midas graphics
!	          = 2 only check results against originals
!	          = 3 create + check (1 + 2)
!	option = MAIN or CLOSEUP
!	plot-flag = YES or NO for showing the graphs
! 
! option MAIN only does some additional HTML stuff we're not
! interested in, so just use CLOSEUP as option for the QCplots
! furthermore, we only have template plots of CLOSEUP for comparison!
! 
! 100420        last modif
!
! ++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
define/param p1 3 n "enter switch:"
define/param p2 C C "enter CLOSEUP (default) or MAIN option:"
define/param p3 no C "enter plot flag (yes/plot or no):"
define/local kk/i/1/1 0
define/local option/c/1/8 "CLOSEUP "
if p2(1:1) .eq. "M" option = "MAIN "
!
write/keyw stop/i/1/1 0
! 
define/local success/i/1/7 0 all 
define/local sc/i/1/5 0 all +low
sc(1) = m$secs()
! 
set/format i1
if p1 .eq. "2" then
   write/out only checking the results for option {option}:
   do kk = 1 6
      $ sh ./auxscript D postscript-{kk}.ps qc-postscript-{kk}{option(1:1)}.ps
      inputi = 1
      write/keyword inputi/i/1/1 <auxscript.txt
      if inputi .ne. 0 success({kk}) = -1
   enddo
   $ sh ./auxscript D postscript.ps qc-postscript{option(1:1)}.ps
   inputi = 1
   write/keyword inputi/i/1/1 <auxscript.txt
   if inputi .ne. 0 success(7) = -1
   goto check_plot
endif
!
if p3 .ne. "NO" then
   define/local plotty/c/1/3 YES
else
   define/local plotty/c/1/3 "NO "
endif
! 
next_step:
if p1 .eq. "1" then
   write/out creating the plots for option {option}:
   do kk = 1 6
      @@ report_DARK_SW_DC_{kk} {option} {plotty}
   enddo
   @@ report_DARK_SW_DC {option} {plotty}
   goto last_part
endif
! 
if p1 .eq. "3" then
   write/out creating the plots + checking the results for option {option}:
   do kk = 1 6
      @@ report_DARK_SW_DC_{kk} {option} {plotty}
      ! 2nd time without plotting, overwriting final postscript file
      set/midas output=y
      if plotty(1:1) .eq. "Y" then
         @@ report_DARK_SW_DC_{kk} {option} 
         set/midas output=y
      endif
      $ sh ./auxscript D postscript-{kk}.ps qc-postscript-{kk}{option(1:1)}.ps
      inputi = 1
      write/keyword inputi/i/1/1 <auxscript.txt
      if inputi .ne. 0 success({kk}) = -1
   enddo
   @@ report_DARK_SW_DC {option} {plotty}
      set/midas output=y
   ! 2nd time without plotting, overwriting final postscript file
   if plotty(1:1) .eq. "Y" then
      @@ report_DARK_SW_DC {option} 
      set/midas output=y
   endif
   $ sh ./auxscript D postscript.ps qc-postscript{option(1:1)}.ps
   inputi = 1
   write/keyword inputi/i/1/1 <auxscript.txt
   if inputi .ne. 0 success(7) = -1
endif
!
check_plot:
set/midas output=y
kk = 0;
do inputi = 1 6
   kk = kk + success({inputi})
   if success({inputi}) .ne. 0 then
      write/out  postscript-{inputi}.ps  not like original qc-postscript-{inputi}{option(1:1)}.ps   ...
   endif
enddo
kk = kk + success(7)
if success(7) .ne. 0 then
   write/out  final postscript.ps not like original qc-postscript{option(1:1)}.ps   ...
endif
! 
if kk .eq. 0 then
   set/midas output=blue
   write/out
   write/out "========================================================="
   write/out "|                                                       |"
   write/out "|    procedure verifyQC terminated successfully ...     |"
   write/out "|                                                       |"
   write/out "========================================================="
   write/out
else
   set/midas output=red
   write/out
   write/out "========================================================="
   write/out "|                                                       |"
   write/out "|           procedure verifyQC failed ...               |"
   write/out "|                                                       |"
   write/out "========================================================="
   write/out
endif
! 
last_part:
set/midas output=y
set/midas output=default
return

! omit display of elapsed time
sc(2) = m$secs()
sc(3) = sc(2)-sc(1)
if p1 .ne. "2" write/out "elapsed time = {sc(3)} secs"
! 
! 
! ----------------------------------------------------
! 
! old host plotting of Postscript files:
! 
! define/local plotcom/c/1/80 " " all
! write/keyw plotcom "$ display -rotate 90          "
!   $ sh ./auxscript P display
!   inputi = 1
!   write/keyword inputi/i/1/1 <auxscript.txt
!   if inputi .eq. 0 then
!      plotty = 1
!      goto next_step
!   endif
!				ask user for viewing command
!   in_a(1:2) = "X#"
!   inquire/keyw in_a -
!   "Enter viewer for final postscript file, or hit ENTER to skip viewing:"
!   if in_a(1:2) .eq. "X#" goto next_step
!   $ sh ./auxscript P {in_a}
!   inputi = 1
!   write/keyword inputi/i/1/1 <auxscript.txt
!   if inputi .eq. 0 plotty = 1
! 
! this was then done via:
!    if plotty .eq. 1 {plotcom} postscript.ps
! 
! ----------------------------------------------------

